- Main Page
- Namespaces
- Classes
- Files
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# _Rb_tree< _Key, _Value, _KeyOfValue, _Compare, _Alloc > Class Template Reference

Inheritance diagram for _Rb_tree< _Key, _Value, _KeyOfValue, _Compare, _Alloc >:

[legend]
Collaboration diagram for _Rb_tree< _Key, _Value, _KeyOfValue, _Compare, _Alloc >:

[legend]
List of all members.

## Public Types
typedef _Key | key_type
typedef _Value | value_type
typedef value_type * | pointer
typedef const value_type * | const_pointer
typedef value_type & | reference
typedef const value_type & | const_reference
typedef _Rb_tree_node * | _Link_type
typedef size_t | size_type
typedef ptrdiff_t | difference_type
typedef _Base::allocator_type | allocator_type
typedef _Rb_tree_iterator< value_type, reference, pointer > | iterator
typedef _Rb_tree_iterator< value_type, const_reference, const_pointer > | const_iterator
typedef reverse_bidirectional_iterator< iterator, value_type, reference, difference_type > | reverse_iterator
typedef reverse_bidirectional_iterator< const_iterator, value_type, const_reference, difference_type > | const_reverse_iterator
## Public Member Functions
allocator_type | get_allocator () const
| _Rb_tree ()
| _Rb_tree (const _Compare &__comp)
| _Rb_tree (const _Compare &__comp, const allocator_type &__a)
| _Rb_tree (const _Rb_tree< _Key, _Value, _KeyOfValue, _Compare, _Alloc > &__x)
| ~_Rb_tree ()
_Rb_tree< _Key, _Value, _KeyOfValue, _Compare, _Alloc > & | operator= (const _Rb_tree< _Key, _Value, _KeyOfValue, _Compare, _Alloc > &__x)
_Compare | key_comp () const
iterator | begin ()
const_iterator | begin () const
iterator | end ()
const_iterator | end () const
reverse_iterator | rbegin ()
const_reverse_iterator | rbegin () const
reverse_iterator | rend ()
const_reverse_iterator | rend () const
bool | empty () const
size_type | size () const
size_type | max_size () const
void | swap (_Rb_tree< _Key, _Value, _KeyOfValue, _Compare, _Alloc > &__t)
pair< iterator, bool > | insert_unique (const value_type &__x)
iterator | insert_equal (const value_type &__x)
iterator | insert_unique (iterator __position, const value_type &__x)
iterator | insert_equal (iterator __position, const value_type &__x)
void | insert_unique (const_iterator __first, const_iterator __last)
void | insert_unique (const value_type *__first, const value_type *__last)
void | insert_equal (const_iterator __first, const_iterator __last)
void | insert_equal (const value_type *__first, const value_type *__last)
void | erase (iterator __position)
size_type | erase (const key_type &__x)
void | erase (iterator __first, iterator __last)
void | erase (const key_type *__first, const key_type *__last)
void | clear ()
iterator | find (const key_type &__x)
const_iterator | find (const key_type &__x) const
size_type | count (const key_type &__x) const
iterator | lower_bound (const key_type &__x)
const_iterator | lower_bound (const key_type &__x) const
iterator | upper_bound (const key_type &__x)
const_iterator | upper_bound (const key_type &__x) const
pair< iterator, iterator > | equal_range (const key_type &__x)
pair< const_iterator, const_iterator > | equal_range (const key_type &__x) const
bool | __rb_verify () const
## Protected Types
typedef _Rb_tree_node_base * | _Base_ptr
typedef _Rb_tree_node< _Value > | _Rb_tree_node
typedef _Rb_tree_Color_type | _Color_type
## Protected Member Functions
_Link_type | _M_create_node (const value_type &__x)
_Link_type | _M_clone_node (_Link_type __x)
void | destroy_node (_Link_type __p)
_Link_type & | _M_root () const
_Link_type & | _M_leftmost () const
_Link_type & | _M_rightmost () const
## Static Protected Member Functions
static _Link_type & | _S_left (_Link_type __x)
static _Link_type & | _S_right (_Link_type __x)
static _Link_type & | _S_parent (_Link_type __x)
static reference | _S_value (_Link_type __x)
static const _Key & | _S_key (_Link_type __x)
static _Color_type & | _S_color (_Link_type __x)
static _Link_type & | _S_left (_Base_ptr __x)
static _Link_type & | _S_right (_Base_ptr __x)
static _Link_type & | _S_parent (_Base_ptr __x)
static reference | _S_value (_Base_ptr __x)
static const _Key & | _S_key (_Base_ptr __x)
static _Color_type & | _S_color (_Base_ptr __x)
static _Link_type | _S_minimum (_Link_type __x)
static _Link_type | _S_maximum (_Link_type __x)
## Protected Attributes
size_type | _M_node_count
_Compare | _M_key_compare

## Detailed Description

### template<class _Key, class _Value, class _KeyOfValue, class _Compare, class _Alloc = __STL_DEFAULT_ALLOCATOR(_Value)>
class _Rb_tree< _Key, _Value, _KeyOfValue, _Compare, _Alloc >

Definition at line 523 of file stl_tree.h.

The documentation for this class was generated from the following file:

- /Users/fpy/titan-1-5-MBARI/Mers/Executives/DeductiveController/Configs/TI_DSP_BIOS/stl/stl_tree.h